/*
 * Copyright 2010-2014 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the iam-2010-05-08.normal.json service model.
 */
using System.Collections.Generic;
using System.IO;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Amazon.IdentityManagement;
using Amazon.IdentityManagement.Model;

namespace AWSSDK_DotNet35.UnitTests.TestTools
{
    [TestClass]
    public class IdentityManagementServiceConstructorCustomizationsTests
    {
        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void AddUserToGroupRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.AddUserToGroupRequest), new System.Type[] { typeof(string), typeof(string), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void CreateAccessKeyRequestConstructorTests()
        {
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void CreateAccountAliasRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.CreateAccountAliasRequest), new System.Type[] { typeof(string), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void CreateGroupRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.CreateGroupRequest), new System.Type[] { typeof(string), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void CreateLoginProfileRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.CreateLoginProfileRequest), new System.Type[] { typeof(string), typeof(string), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void CreateUserRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.CreateUserRequest), new System.Type[] { typeof(string), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void DeactivateMFADeviceRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.DeactivateMFADeviceRequest), new System.Type[] { typeof(string), typeof(string), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void DeleteAccessKeyRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.DeleteAccessKeyRequest), new System.Type[] { typeof(string), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void DeleteAccountAliasRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.DeleteAccountAliasRequest), new System.Type[] { typeof(string), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void DeleteGroupRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.DeleteGroupRequest), new System.Type[] { typeof(string), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void DeleteGroupPolicyRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.DeleteGroupPolicyRequest), new System.Type[] { typeof(string), typeof(string), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void DeleteLoginProfileRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.DeleteLoginProfileRequest), new System.Type[] { typeof(string), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void DeleteServerCertificateRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.DeleteServerCertificateRequest), new System.Type[] { typeof(string), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void DeleteSigningCertificateRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.DeleteSigningCertificateRequest), new System.Type[] { typeof(string), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void DeleteUserRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.DeleteUserRequest), new System.Type[] { typeof(string), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void DeleteUserPolicyRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.DeleteUserPolicyRequest), new System.Type[] { typeof(string), typeof(string), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void GetGroupRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.GetGroupRequest), new System.Type[] { typeof(string), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void GetGroupPolicyRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.GetGroupPolicyRequest), new System.Type[] { typeof(string), typeof(string), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void GetLoginProfileRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.GetLoginProfileRequest), new System.Type[] { typeof(string), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void GetServerCertificateRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.GetServerCertificateRequest), new System.Type[] { typeof(string), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void GetUserRequestConstructorTests()
        {
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void GetUserPolicyRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.GetUserPolicyRequest), new System.Type[] { typeof(string), typeof(string), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void ListAccessKeysRequestConstructorTests()
        {
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void ListAccountAliasesRequestConstructorTests()
        {
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void ListGroupPoliciesRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.ListGroupPoliciesRequest), new System.Type[] { typeof(string), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void ListGroupsRequestConstructorTests()
        {
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void ListGroupsForUserRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.ListGroupsForUserRequest), new System.Type[] { typeof(string), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void ListMFADevicesRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.ListMFADevicesRequest), new System.Type[] { typeof(string), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void ListServerCertificatesRequestConstructorTests()
        {
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void ListSigningCertificatesRequestConstructorTests()
        {
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void ListUserPoliciesRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.ListUserPoliciesRequest), new System.Type[] { typeof(string), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void ListUsersRequestConstructorTests()
        {
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void PutGroupPolicyRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.PutGroupPolicyRequest), new System.Type[] { typeof(string), typeof(string), typeof(string), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void PutUserPolicyRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.PutUserPolicyRequest), new System.Type[] { typeof(string), typeof(string), typeof(string), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void RemoveUserFromGroupRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.RemoveUserFromGroupRequest), new System.Type[] { typeof(string), typeof(string), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void UpdateAccessKeyRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.UpdateAccessKeyRequest), new System.Type[] { typeof(string), typeof(StatusType), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void UpdateGroupRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.UpdateGroupRequest), new System.Type[] { typeof(string), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void UpdateLoginProfileRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.UpdateLoginProfileRequest), new System.Type[] { typeof(string), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void UpdateServerCertificateRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.UpdateServerCertificateRequest), new System.Type[] { typeof(string), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void UpdateSigningCertificateRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.UpdateSigningCertificateRequest), new System.Type[] { typeof(string), typeof(StatusType), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void UpdateUserRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.UpdateUserRequest), new System.Type[] { typeof(string), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void UploadServerCertificateRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.UploadServerCertificateRequest), new System.Type[] { typeof(string), typeof(string), typeof(string), });
        }

        [TestMethod]
        [TestCategory("UnitTest")]
        [TestCategory("Constructors"), TestCategory("IdentityManagementService")]
        public void UploadSigningCertificateRequestConstructorTests()
        {
            EnsureConstructorExists(typeof(Amazon.IdentityManagement.Model.UploadSigningCertificateRequest), new System.Type[] { typeof(string), });
        }

        void EnsureConstructorExists(System.Type type, System.Type[] constructorParams)
        {
            Assert.IsNotNull(type.GetConstructor(constructorParams));
        }
    }
}