/*
 * Copyright 2010-2014 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the storagegateway-2013-06-30.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Net;
using System.Text;
using System.Xml.Serialization;

using Amazon.StorageGateway.Model;
using Amazon.Runtime;
using Amazon.Runtime.Internal;
using Amazon.Runtime.Internal.Transform;
using Amazon.Runtime.Internal.Util;
using ThirdParty.Json.LitJson;

namespace Amazon.StorageGateway.Model.Internal.MarshallTransformations
{
    /// <summary>
    /// Response Unmarshaller for VTLDevice Object
    /// </summary>  
    public class VTLDeviceUnmarshaller : IUnmarshaller<VTLDevice, XmlUnmarshallerContext>, IUnmarshaller<VTLDevice, JsonUnmarshallerContext>
    {
        VTLDevice IUnmarshaller<VTLDevice, XmlUnmarshallerContext>.Unmarshall(XmlUnmarshallerContext context)
        {
            throw new NotImplementedException();
        }

        public VTLDevice Unmarshall(JsonUnmarshallerContext context)
        {
            context.Read();
            if (context.CurrentTokenType == JsonToken.Null) 
                return null;

            VTLDevice unmarshalledObject = new VTLDevice();
        
            int targetDepth = context.CurrentDepth;
            while (context.ReadAtDepth(targetDepth))
            {
                if (context.TestExpression("DeviceiSCSIAttributes", targetDepth))
                {
                    var unmarshaller = DeviceiSCSIAttributesUnmarshaller.Instance;
                    unmarshalledObject.DeviceiSCSIAttributes = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("VTLDeviceARN", targetDepth))
                {
                    var unmarshaller = StringUnmarshaller.Instance;
                    unmarshalledObject.VTLDeviceARN = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("VTLDeviceProductIdentifier", targetDepth))
                {
                    var unmarshaller = StringUnmarshaller.Instance;
                    unmarshalledObject.VTLDeviceProductIdentifier = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("VTLDeviceType", targetDepth))
                {
                    var unmarshaller = StringUnmarshaller.Instance;
                    unmarshalledObject.VTLDeviceType = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("VTLDeviceVendor", targetDepth))
                {
                    var unmarshaller = StringUnmarshaller.Instance;
                    unmarshalledObject.VTLDeviceVendor = unmarshaller.Unmarshall(context);
                    continue;
                }
            }
          
            return unmarshalledObject;
        }


        private static VTLDeviceUnmarshaller _instance = new VTLDeviceUnmarshaller();        

        public static VTLDeviceUnmarshaller Instance
        {
            get
            {
                return _instance;
            }
        }
    }
}